# Copyright 2016 Hubert Jarosz

# to make it work on Python2
from __future__ import absolute_import
from __future__ import print_function
from __future__ import division
from __future__ import unicode_literals

#

def my_rq(A):
    Q,R = numpy.linalg.qr(numpy.flipud(A).T)
    R = numpy.flipud(R.T)
    Q = Q.T
    return R[:,::-1], Q[::-1,:]


import numpy
import sys
#import scipy.linalg # for scipy.linalg.rq
import math

numpy.set_printoptions(suppress=True)

def getM(A):
    U, S, V = numpy.linalg.svd(A)
    M = V[-1:,]  # last column
    return numpy.reshape(M, (3,-1))

def getF_(A):
    U, S, V = numpy.linalg.svd(A)
    F = V[-1:,]  # last column
    print(A)
    print("---")
    print(V)
    return numpy.reshape(F, (3,3))

def getF(A):
    U, S, V = numpy.linalg.svd(getF_(A))
    S[2] = 0
    return U.dot(numpy.diag(S)).dot(V)

txt = numpy.loadtxt("./data/pts3d-norm.txt")
txtlen = txt.shape[0]
uv = numpy.loadtxt("./data/pts2d-norm-pic_a.txt")
if txtlen != uv.shape[0]:
    print("ERROR: bad input!")
    sys.exit(1)

A = numpy.empty((2*txtlen, 12))

for line in range(txtlen):
    xyzw = numpy.concatenate([txt[line], [1]])
    A[2*line] = numpy.concatenate([xyzw, [0,0,0,0], [ -1*uv[line][0]*l for l in xyzw ]])
    A[2*line+1] = numpy.concatenate([[0,0,0,0], xyzw, [ -1*uv[line][1]*l for l in xyzw ]])

M = getM(A)


for line in range(txtlen):
    xyzw = numpy.concatenate([txt[line], [1]])
    new_uv = M.dot(numpy.reshape(xyzw, (4,1)))
    xdiff = uv[line][0] - new_uv[0]/new_uv[2]
    ydiff = uv[line][1] - new_uv[1]/new_uv[2]
    diff = math.sqrt(xdiff**2 + ydiff**2)
    if diff >= 0.01:
        print("Big diff", diff, "for point nr", line, "!")


#K, R = scipy.linalg.rq(M[:,:3])#[:3:,])

K, R = my_rq(M[:,:3])#[:3:,])


tmp = numpy.diag(numpy.sign(numpy.diag(K)))
#if numpy.linalg.det(tmp) < 0:
#    tmp[1,1] *= -1

K = numpy.dot(K,tmp)  # camera parameters
R = numpy.dot(tmp,R)  # camera rotation matrix

T = numpy.linalg.inv(K).dot(M[:,-1])  # world origin

C = -(R.T).dot(T) # camera center

A = numpy.empty((8, 9))

for i in range(8):
    xyzw = numpy.concatenate([txt[line], [1]])
    new_uv = M.dot(numpy.reshape(xyzw, (4,1)))
    new_uv = new_uv.T[0]
    new_uv[0] /= new_uv[2]
    new_uv[1] /= new_uv[2]
    A[i] = [xyzw[0]*new_uv[0], xyzw[0]*new_uv[1], xyzw[0], xyzw[1]*new_uv[0], xyzw[1]*new_uv[1], xyzw[1], new_uv[0], new_uv[1], 1]

F = getF(A)

# print("Projection matrix:\n", M, "\n")
# print("Camera internals:\n", K, "\n")
# print("Camera rotation:\n", R, "\n")
# print("World origin:\n", T, "\n")
# print("Camera center:\n", C, "\n")
# print("Fundamental matrix:\n", F, "\n")
